library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.numeric_std.all;

entity ddspulz is  -- DDS sinusni generator tonov s pulznim izhodom
  port (
    clk  : in  std_logic;
	 n : in unsigned(3 downto 0);   -- nota in oktava
    pwm : out std_logic            -- pulzni DDS izhod
    );
end ddspulz;

architecture rtl of ddspulz is
  signal st  : unsigned (23 downto 0) := (others => '0');
  signal st0 : integer range 0 to 167 := 0;
  signal ok  : integer range 0 to 10  := 1;
  
  -------------------------------------------------------------------------  
  signal n0 : unsigned (4 downto 0) := "00000";
  signal data: signed(7 downto 0);
  signal pcnt: unsigned(7 downto 0) := (others=>'0');
begin

  n0 <= "0" & n;

  process (n0) -- n0(4:3) doloca oktavo!
  begin
    case n0(4 downto 3) is
      when "01"   => ok <= 2;
      when "10"   => ok <= 4;
      when "11"   => ok <= 8;
      when others => ok <= 1;
    end case;
  end process;

  process(n0)
  begin
    case n0(2 downto 0) is -- n0(2:0) doloca noto!
      when "001"  => st0 <= 88;
      when "010"  => st0 <= 99;
      when "011"  => st0 <= 111;
      when "100"  => st0 <= 117;
      when "101"  => st0 <= 132;
      when "110"  => st0 <= 148;
      when "111"  => st0 <= 166;
      when others => st0 <= 0;
    end case;
  end process;

  p : process(clk) -- DDS fazni akumulator
  begin
    if rising_edge(clk) then
      st <= st + to_unsigned(st0*ok, 24);
    end if;
  end process;

  -- ROM s sinusno tabelo
  u0 : entity work.rom port map(unsigned(st(23 downto 18)), data);
  
  -- PWM izhod
  pwmproc: process(clk)
  begin
  if rising_edge(clk) then
	 if pcnt="11111110" then
	   pcnt <= "00000000";
	 else	   
		pcnt <= pcnt + 1;
	 end if;
	 
	 if pcnt < unsigned(data)+"10000000" then
	   pwm <= '1';
	 else 
	   pwm <= '0';
	 end if;
  end if;
  end process;
  
end rtl;
